//
// Stack of real numbers, implementation
//
#include "stdafx.h"
#include "RealStack.h"

RealStack::RealStack():
    stack(0),
    max_size(STACK_MAXSIIZE),
    cur_size(0)
{
    stack = new double[max_size];
}

RealStack::RealStack(int maxSize):
    stack(0),
    max_size(maxSize),
    cur_size(0)
{
    stack = new double[max_size];
}

RealStack::~RealStack() {
    delete[] stack;
}

void RealStack::push(double x) throw (StackException) {
    if (cur_size >= max_size)
        throw StackException("Stack overflow");
    stack[cur_size] = x;
    ++cur_size;
}

double RealStack::pop() throw (StackException) {
    if (cur_size == 0)
        throw StackException("Stack empty");
    double x = stack[cur_size - 1];
    --cur_size;
    return x;
}

double RealStack::top() const throw (StackException) {
    if (cur_size == 0)
        throw StackException("Stack empty");
    return stack[cur_size - 1];
}

void RealStack::init() {
    cur_size = 0;
}

bool RealStack::empty() const {
    return (cur_size == 0);
}

double RealStack::elementAt(int i) const throw (StackException) {
    if (i >= cur_size)
        throw StackException("Out of bounds");
    return stack[cur_size - 1 - i];
}
