// StCalcDlg.cpp : implementation file
//

#include "stdafx.h"
#include <cmath>
#include "StCalc.h"
#include "StCalcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    enum { IDD = IDD_ABOUTBOX };

    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CStCalcDlg dialog




CStCalcDlg::CStCalcDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CStCalcDlg::IDD, pParent)
    , m_sRes(_T(""))
    , m_sInput(_T(""))
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStCalcDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_RES, m_sRes);
    DDX_Text(pDX, IDC_INPUT, m_sInput);
}

BEGIN_MESSAGE_MAP(CStCalcDlg, CDialog)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_PUSH, &CStCalcDlg::OnBnClickedPush)
    ON_BN_CLICKED(IDC_PLUS, &CStCalcDlg::OnBnClickedPlus)
    ON_BN_CLICKED(IDC_MINUS, &CStCalcDlg::OnBnClickedMinus)
    ON_BN_CLICKED(IDC_MUL, &CStCalcDlg::OnBnClickedMul)
    ON_BN_CLICKED(IDC_DIV, &CStCalcDlg::OnBnClickedDiv)
    ON_BN_CLICKED(IDC_SQRT, &CStCalcDlg::OnBnClickedSqrt)
    ON_BN_CLICKED(IDC_EXP, &CStCalcDlg::OnBnClickedExp)
    ON_BN_CLICKED(IDC_SIN, &CStCalcDlg::OnBnClickedSin)
    ON_BN_CLICKED(IDC_COS, &CStCalcDlg::OnBnClickedCos)
    ON_BN_CLICKED(IDC_PI, &CStCalcDlg::OnBnClickedPi)
    ON_BN_CLICKED(IDC_E, &CStCalcDlg::OnBnClickedE)
    ON_BN_CLICKED(IDC_POP, &CStCalcDlg::OnBnClickedPop)
    ON_BN_CLICKED(IDC_INIT, &CStCalcDlg::OnBnClickedInit)
    ON_BN_CLICKED(IDC_DUP, &CStCalcDlg::OnBnClickedDup)
    ON_BN_CLICKED(IDC_EXCH, &CStCalcDlg::OnBnClickedExch)
    ON_EN_KILLFOCUS(IDC_INPUT, &CStCalcDlg::OnEnKillfocusInput)
END_MESSAGE_MAP()


// CStCalcDlg message handlers

BOOL CStCalcDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here
    int titleHeight = ::GetSystemMetrics(SM_CYSIZE);
    CRect r;
    GetDlgItem(IDC_MINUS)->GetWindowRect(r);
    m_StackX = r.right + 8;
    m_StackY = r.top - titleHeight;

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStCalcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStCalcDlg::OnPaint()
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        //... CDialog::OnPaint();
        CPaintDC dc(this); // device context for painting
        dc.SetBkMode(TRANSPARENT);
        CPen p(PS_SOLID, 1, RGB(200, 20, 20));
        dc.SelectObject(&p);

        // Draw the stack contents
        int n = m_Stack.depth();
        int maxWidth = 100;
        int x = m_StackX + 16;
        int y = m_StackY;
        int skip = 2;
        int dy = 0;
        for (int i = 0; i < n; ++i)
        {
            double v = m_Stack.elementAt(i);
            CString txt;
            txt.Format(_T("%lf"), v);
            CSize s = dc.GetTextExtent(txt);
            CRect textRect(
                x, y, x + s.cx, y + s.cy
            );
            dc.DrawText(
                txt, textRect, DT_LEFT | DT_VCENTER
            );
            if (s.cx > maxWidth)
                maxWidth = s.cx;
            dy = s.cy + skip;
            y += dy;
        }
        // Draw the stack frame
        dc.MoveTo(m_StackX, m_StackY);
        x = m_StackX + 8;
        dc.LineTo(x, m_StackY);
        int yBottom = m_StackY + n * dy + skip;
        if (n == 0)
            yBottom += 8;
        dc.LineTo(x, yBottom);
        dc.LineTo(x + maxWidth + 16, yBottom);
        dc.LineTo(x + maxWidth + 16, m_StackY);
        dc.LineTo(x + maxWidth + 24, m_StackY);
    }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStCalcDlg::OnQueryDragIcon()
{
    return static_cast<HCURSOR>(m_hIcon);
}


void CStCalcDlg::OnBnClickedPush()
{
    // TODO: Add your control notification handler code here
    UpdateData();
    if (m_sInput == _T(""))
        return;
    double x = _wtof(m_sInput);
    try
    {
        m_Stack.push(x);
        m_sInput = "";
        UpdateData(FALSE);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::Display()
{
    if (m_Stack.size() == 0)
        m_sRes = _T("");
    else
        m_sRes.Format(_T("%lf"), m_Stack.top());
    Invalidate();
    UpdateData(FALSE);
}

void CStCalcDlg::OnBnClickedPlus()
{
    // TODO: Add your control notification handler code here
    try
    {
        double y = m_Stack.pop();
        double x = m_Stack.pop();
        double res = x + y;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedMinus()
{
    // TODO: Add your control notification handler code here
    try
    {
        double y = m_Stack.pop();
        double x = m_Stack.pop();
        double res = x - y;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedMul()
{
    // TODO: Add your control notification handler code here
    try
    {
        double y = m_Stack.pop();
        double x = m_Stack.pop();
        double res = x * y;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedDiv()
{
    // TODO: Add your control notification handler code here
    try
    {
        double y = m_Stack.pop();
        double x = m_Stack.pop();
        double res = x / y;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedSqrt()
{
    // TODO: Add your control notification handler code here
    try
    {
        double x = m_Stack.pop();
        double res = sqrt(x);
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedExp()
{
    // TODO: Add your control notification handler code here
    try
    {
        double x = m_Stack.pop();
        double res = exp(x);
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedSin()
{
    // TODO: Add your control notification handler code here
    try
    {
        double x = m_Stack.pop();
        double res = sin(x);
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedCos()
{
    // TODO: Add your control notification handler code here
    try
    {
        double x = m_Stack.pop();
        double res = cos(x);
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedPi()
{
    // TODO: Add your control notification handler code here
    try
    {
        double res = 3.14159265358979323846;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedE()
{
    // TODO: Add your control notification handler code here
    try
    {
        double res = 2.7182818284590452354;
        m_Stack.push(res);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedPop()
{
    // TODO: Add your control notification handler code here
    try
    {
        m_Stack.pop();
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedInit()
{
    // TODO: Add your control notification handler code here
    m_Stack.init();
    Display();
}

void CStCalcDlg::OnBnClickedDup()
{
    // TODO: Add your control notification handler code here
    try
    {
        double x = m_Stack.pop();
        m_Stack.push(x);
        m_Stack.push(x);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnBnClickedExch()
{
    // TODO: Add your control notification handler code here
    try
    {
        double y = m_Stack.pop();
        double x = m_Stack.pop();
        m_Stack.push(y);
        m_Stack.push(x);
        Display();
    }
    catch (StackException& e)
    {
        m_sRes = "Exception: ";
        m_sRes += e.reason;
        UpdateData(FALSE);
    }
    Invalidate();   // Redraw the window
}

void CStCalcDlg::OnEnKillfocusInput()
{
    // TODO: Add your control notification handler code here
    UpdateData();
    if (m_sInput != _T(""))
        OnBnClickedPush();
}
